#ifndef _ASM_H
#define _ASM_H

#ifndef _ASM_ASSEMBLY_
#error Don't include this header in C sources
#endif

/* Import assembly functions */
#define IMPORT_ASM(name) \
            .extern name ;

/* Import C functions */
#define IMPORT_C(name) \
            .extern name ;

/* Entry */
#define ENTRY(name) ; \
        .globl name ; \
        .align ; \
        name: ;

/* Function */
#define FUNCTION_S(name) ; \
        .func name,name ; \
        .type name,%function ; \
        .globl name ; \
        .align ; \
        name: ;

#define FUNCTION_E(name) ; \
        .size name, . - name ; \
        .endfunc ;

#endif
