#include <stddef.h>

void *memcpy_c_v1(void *dst, const void *src, size_t num)
{
    size_t i;
    unsigned char *p_dst;
    unsigned char *p_src;
    
    p_dst = (unsigned char *) dst;
    p_src = (unsigned char *) src;
    
    for (i = 0; i < num; i++) {
        *p_dst = *p_src;
        p_dst++;
        p_src++;
    }
    
    return dst;
}

void *memcpy_c_v2(void *dst, const void *src, size_t num)
{
    size_t i;
    size_t cnt;
    size_t rem;
    unsigned char *p_dst;
    unsigned char *p_src;
    unsigned long int *p64_dst;
    unsigned long int *p64_src;
    
    cnt = (num / sizeof(unsigned long int));
    rem = (num % sizeof(unsigned long int));
    
    if (cnt) {
        p64_dst = (unsigned long int *) dst;
        p64_src = (unsigned long int *) src;
        
        for (i = 0; i < (num / sizeof(unsigned long int)); i++) {
            *p64_dst = *p64_src;
            p64_dst++;
            p64_src++;
        }
        
        if (!rem)
            return dst;
    }
    
    if (rem) {
        p_dst = (unsigned char *) dst;
        p_src = (unsigned char *) src;
        
        for (i = 0; i < (num / sizeof(unsigned long int)); i++) {
            *p_dst = *p_src;
            p_dst++;
            p_src++;
        }
    }
    
    return dst;
}
